#include <basic.h>

int byteToServo(byte data, unsigned range) // calculates pulse time
{
  int res;
  switch(data)
  {
  case 0:
    res = 1395;
    break;
  case 1:
    res = 1410;
    break;
  case 2:
    res = 1425;
    break;
  case 3:
    res = 1440;
    break;
  case 4:
    res = 1455;
    break;
  case 5:
    res = 1470;
    break;
  case 6:
    res = 1485;
    break;
  case 7:
    res = 1500;
    break;
  case 8:
    res = 1500;
    break;
  case 9:
    res = 1515;
    break;
  case 10:
    res = 1530;
    break;
  case 11:
    res = 1545;
    break;
  case 12:
    res = 1560;
    break;
  case 13:
    res = 1575;
    break;
  case 14:
    res = 1590;
    break;
  case 15:
    res = 1605;
    break;
  }
  return res;
}

int byteToServo2(byte data, unsigned range) // calculates pulse time
{
  int res;
  switch(data)
  {
  case 0:
    res = 975;
    break;
  case 1:
    res = 1050;
    break;
  case 2:
    res = 1125;
    break;
  case 3:
    res = 1200;
    break;
  case 4:
    res = 1275;
    break;
  case 5:
    res = 1350;
    break;
  case 6:
    res = 1425;
    break;
  case 7:
    res = 1500;
    break;
  case 8:
    res = 1500;
    break;
  case 9:
    res = 1575;
    break;
  case 10:
    res = 1650;
    break;
  case 11:
    res = 1725;
    break;
  case 12:
    res = 1800;
    break;
  case 13:
    res = 1875;
    break;
  case 14:
    res = 1950;
    break;
  case 15:
    res = 2025;
    break;
  }
  return res;
}

void setup()
{
  servoReady(); // make servo pins outputs and low
  Serial.begin(2400); // begin to listen to radio data
}

void loop()
{
  byte temp;
  int l; // wheel speeds
  int r;
  int x; // head position
  int y;
  while(1) // forever loop
  {
    temp = serialWaitRead();
#ifdef debug // display text to serial monitor
    // anything inside "#ifdef debug" won't be actually excuted unless you define debug
    Serial.print("Encoder: ");
    Serial.println(temp, BIN);
#endif
    if(temp == B11011011) // if data type is drive data
    {
      temp = serialWaitRead(); // read packet
#ifdef debug
      Serial.print("Packet: ");
      Serial.println(temp, BIN);
#endif
      serialEnd(); // disables serial interrupt
      // this ensures correct uninterrupted timing for servos
      // very important or else you can have a buffer overflow too
      l = byteToServo(15 - ((temp & 0xF0) >> 4), 125); // decode packet
      r = byteToServo(temp & 0x0F, 125);
      servoUpdateDrive(l, r); // tell servos what to do
      Serial.flush(); // clear serial buffer
      serialRestart(); // re-enable interrupt
#ifdef debug
      Serial.print("Left Speed: ");
      Serial.println(l, DEC);
      Serial.print("Right Speed: ");
      Serial.println(r, DEC);
#endif
    }
    else if(temp == B11100111) // data type to control head
    {
      temp = serialWaitRead(); // gets packet
#ifdef debug
      Serial.print("Packet: ");
      Serial.println(temp, BIN);
#endif
      serialEnd(); // same as above
      x = byteToServo2((temp & 0xF0) >> 4, 125);
      y = byteToServo2(temp & 0x0F, 125);     
      servoUpdateHead(x, y);
      Serial.flush();
      serialRestart();
#ifdef debug
      Serial.print("X: ");
      Serial.println(x, DEC);
      Serial.print("Y: ");
      Serial.println(y, DEC);
#endif
    }
  }
}
